=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-09-06 17:55:13 +0000
+++ viz/branchwin.py	2007-09-09 17:52:49 +0000
@@ -12,11 +12,13 @@
 import gtk
 import gobject
 import pango
+import treemodel
 
 from bzrlib.osutils import format_date
 
 from linegraph import linegraph, same_branch
 from graphcell import CellRendererGraph
+from treemodel import TreeModel
 
 
 class BranchWindow(gtk.Window):
@@ -86,16 +88,16 @@
         column = gtk.TreeViewColumn("Revision No")
         column.set_resizable(True)
         column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 9)
+        column.add_attribute(cell, "text", treemodel.REVNO)
         self.treeview.append_column(column)
 
         cell = CellRendererGraph()
         column = gtk.TreeViewColumn()
         column.set_resizable(True)
         column.pack_start(cell, expand=False)
-        column.add_attribute(cell, "node", 1)
-        column.add_attribute(cell, "in-lines", 2)
-        column.add_attribute(cell, "out-lines", 3)
+        column.add_attribute(cell, "node", treemodel.NODE)
+        column.add_attribute(cell, "in-lines", treemodel.LAST_LINES)
+        column.add_attribute(cell, "out-lines", treemodel.LINES)
         self.treeview.append_column(column)
 
         cell = gtk.CellRendererText()
@@ -104,7 +106,7 @@
         column = gtk.TreeViewColumn("Message")
         column.set_resizable(True)
         column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 6)
+        column.add_attribute(cell, "text", treemodel.MESSAGE)
         self.treeview.append_column(column)
 
         cell = gtk.CellRendererText()
@@ -113,7 +115,7 @@
         column = gtk.TreeViewColumn("Committer")
         column.set_resizable(True)
         column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 7)
+        column.add_attribute(cell, "text", treemodel.COMMITER)
         self.treeview.append_column(column)
 
         cell = gtk.CellRendererText()
@@ -121,7 +123,7 @@
         column = gtk.TreeViewColumn("Date")
         column.set_resizable(True)
         column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 8)
+        column.add_attribute(cell, "text", treemodel.TIMESTAMP)
         self.treeview.append_column(column)
 
         return scrollwin
@@ -173,15 +175,6 @@
         treeview itself.
         """
         self.branch = branch
-
-        # [ revision, node, last_lines, lines, message, committer, timestamp ]
-        self.model = gtk.ListStore(gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   str, str, str, str)
         self.set_title(branch.nick + " - bzrk")
         gobject.idle_add(self.populate_model, start, maxnum)
 
@@ -189,51 +182,17 @@
         (linegraphdata, index) = linegraph(self.branch,
                                            start,
                                            maxnum)
-        print "linegraph compleate"
+        self.model = TreeModel(self.branch, linegraphdata)
         self.index = index
-        self.revisions = []
-        
-        last_lines = []
-        for (index,(revid,
-                    node,
-                    lines,
-                    parents,
-                    children,
-                    revno_sequence)) in enumerate(linegraphdata):
-            # FIXME: at this point we should be able to show the graph order
-            # and lines with no message or commit data - and then incrementally
-            # fill the timestamp, committer etc data as desired.
-            
-            revision = self.branch.repository.get_revisions([revid])[0]
-            self.revisions.append(revision)
-            
-            message = revision.message.split("\n")[0]
-            
-            if revision.committer is not None:
-                timestamp = format_date(revision.timestamp, revision.timezone)
-            else:
-                timestamp = None
-            revno_string = ".".join(["%d" % (revno) for revno in revno_sequence])
-            
-            self.model.append([revision,
-                               node,
-                               last_lines,
-                               lines,
-                               parents,
-                               children, 
-                               message,
-                               revision.committer,
-                               timestamp,
-                               revno_string])
-            last_lines = lines
         self.treeview.set_model(self.model)
 
     def _treeview_cursor_cb(self, *args):
         """Callback for when the treeview cursor changes."""
         (path, col) = self.treeview.get_cursor()
-        revision = self.model[path][0]
-        parents = self.model[path][4]
-        children = self.model[path][5]
+        iter = self.model.get_iter(path)
+        revision = self.model.get_value(iter, treemodel.REVISION)
+        parents = self.model.get_value(iter, treemodel.PARENTS)
+        children = self.model.get_value(iter, treemodel.CHILDREN)
 
         self.back_button.set_sensitive(len(parents) > 0)
         self.fwd_button.set_sensitive(len(children) > 0)

=== added file 'viz/treemodel.py'
--- viz/treemodel.py	1970-01-01 00:00:00 +0000
+++ viz/treemodel.py	2007-09-09 17:52:49 +0000
@@ -0,0 +1,110 @@
+# -*- coding: UTF-8 -*-
+"""Tree model.
+
+"""
+
+__copyright__ = "Copyright  2005 Canonical Ltd."
+__author__    = "Gary van der Merwe <garyvdm@gmail.com>"
+
+
+import gtk
+import gobject
+import pango
+
+from bzrlib.osutils import format_date
+
+REVID = 0
+NODE = 1
+LINES = 2
+LAST_LINES = 3
+REVNO = 4
+MESSAGE = 5
+COMMITER = 6
+TIMESTAMP = 7
+REVISION = 8
+PARENTS = 9
+CHILDREN = 10
+
+class TreeModel(gtk.GenericTreeModel):
+
+    
+    def __init__ (self, branch, line_graph_data):
+        gtk.GenericTreeModel.__init__(self)
+        self.revisions = {}
+        self.branch = branch
+        self.line_graph_data = line_graph_data
+    
+    def on_get_flags(self):
+        return gtk.TREE_MODEL_LIST_ONLY
+    
+    def on_get_n_columns(self):
+        return 11
+    
+    def on_get_column_type(self, index):
+        if index == REVID: return gobject.TYPE_STRING
+        if index == NODE: return gobject.TYPE_PYOBJECT
+        if index == LINES: return gobject.TYPE_PYOBJECT
+        if index == LAST_LINES: return gobject.TYPE_PYOBJECT
+        if index == REVNO: return gobject.TYPE_STRING
+        if index == MESSAGE: return gobject.TYPE_STRING
+        if index == COMMITER: return gobject.TYPE_STRING
+        if index == TIMESTAMP: return gobject.TYPE_STRING
+        if index == REVISION: return gobject.TYPE_PYOBJECT
+        if index == PARENTS: return gobject.TYPE_PYOBJECT
+        if index == CHILDREN: return gobject.TYPE_PYOBJECT
+        
+    def on_get_iter(self, path):
+        return path[0]
+    
+    def on_get_path(self, rowref):
+        return rowref
+    
+    def on_get_value(self, rowref, column):
+        (revid, node, lines, parents,
+         children, revno_sequence) = self.line_graph_data[rowref]
+        if column == REVID: return revid
+        if column == NODE: return node
+        if column == LINES: return lines
+        if column == PARENTS: return parents
+        if column == CHILDREN: return children
+        if column == LAST_LINES:
+            if rowref>0:
+                return self.line_graph_data[rowref-1][2]
+            return []
+        if column == REVNO: return ".".join(["%d" % (revno)
+                                      for revno in revno_sequence])
+        
+        if revid not in self.revisions:
+            revision = self.branch.repository.get_revisions([revid])[0]
+            self.revisions[revid] = revision
+        else:
+            revision = self.revisions[revid]
+        
+        if column == REVISION: return revision
+        if column == MESSAGE: return revision.message.split("\n")[0]
+        if column == COMMITER: return revision.committer
+        if column == TIMESTAMP: return format_date(revision.timestamp,
+                                                   revision.timezone)
+    
+    def on_iter_next(self, rowref):
+        if rowref < len(self.line_graph_data):
+            return rowref+1
+        return None
+    
+    def on_iter_children(self, parent):
+        if parent is None: return 0
+        return None
+    
+    def on_iter_has_child(self, rowref):
+        return False
+    
+    def on_iter_n_children(self, rowref):
+        if rowref is None: return len(self.line_graph_data)
+        return 0
+    
+    def on_iter_nth_child(self, parent, n):
+        if parent is None: return n
+        return None
+    
+    def on_iter_parent(self, child):
+        return None

